# by Defiant <mail@defiant.homedns.org>


# Imports
import App
import MissionLib
import Bridge.BridgeUtils
import QuickBattle.QuickBattle

# Vars
pBridge = App.g_kSetManager.GetSet('bridge')
g_pKiska = App.CharacterClass_GetObject(pBridge, 'Helm')
pKiskaMenu = Bridge.BridgeUtils.GetBridgeMenu('Helm')
STAY = App.Mission_GetNextEventType()
ATTACK = App.Mission_GetNextEventType()
FOLLOW_THROUGH_WARP = App.Mission_GetNextEventType()
STAYFLEET = App.Mission_GetNextEventType()
ATTACKFLEET = App.Mission_GetNextEventType()
FOLLOW_THROUGH_WARP_FLEET = App.Mission_GetNextEventType()
FLY_FORWARD = App.Mission_GetNextEventType()
ATTACK_MY_TARGET = App.Mission_GetNextEventType()
SELF_DESTRUCT = App.Mission_GetNextEventType()
g_pMyTargetTarget = None

if (pKiskaMenu != None):
	pButtonOrder = App.STMenu_CreateW(App.TGString("Order..."))
	pKiskaMenu.PrependChild(pButtonOrder)
	
	pButtonOrderShip = App.STMenu_CreateW(App.TGString("Ship..."))
	pButtonOrder.PrependChild(pButtonOrderShip)
	
	pButtonOrderFleet = App.STMenu_CreateW(App.TGString("Fleet..."))
	pButtonOrder.PrependChild(pButtonOrderFleet)
	
	g_pKiska.AddPythonFuncHandlerForInstance(STAY, __name__ + ".Stay")
	pButtonStay = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Stop"), STAY, 0, g_pKiska)
	pButtonOrderShip.PrependChild(pButtonStay)
	
	g_pKiska.AddPythonFuncHandlerForInstance(ATTACK, __name__ + ".Attack")
	pButtonAttack = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Attack"), ATTACK, 0, g_pKiska)
	pButtonOrderShip.PrependChild(pButtonAttack)
	
	g_pKiska.AddPythonFuncHandlerForInstance(FLY_FORWARD, __name__ + ".FlyForward")
	pButtonFlyForward = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Fly Forward"), FLY_FORWARD, 0, g_pKiska)
	pButtonOrderShip.PrependChild(pButtonFlyForward)
	
	g_pKiska.AddPythonFuncHandlerForInstance(FOLLOW_THROUGH_WARP, __name__ + ".FollowThroughWarp")
	pButtonFollow = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Follow"), FOLLOW_THROUGH_WARP, 0, g_pKiska)
	pButtonOrderShip.PrependChild(pButtonFollow)
	
        pButtonSD = App.STMenu_CreateW(App.TGString("Self Destruct"))
	pButtonOrderShip.PrependChild(pButtonSD)
        
	g_pKiska.AddPythonFuncHandlerForInstance(SELF_DESTRUCT, __name__ + ".SelfDestruct")
	pButtonSD2 = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Yes"), SELF_DESTRUCT, 0, g_pKiska)
	pButtonSD.PrependChild(pButtonSD2)

	g_pKiska.AddPythonFuncHandlerForInstance(STAYFLEET, __name__ + ".StayFleet")
	pButtonStay = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Stop"), STAYFLEET, 0, g_pKiska)
	pButtonOrderFleet.PrependChild(pButtonStay)
	
	g_pKiska.AddPythonFuncHandlerForInstance(ATTACKFLEET, __name__ + ".AttackFleet")
	pButtonAttack = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Attack"), ATTACKFLEET, 0, g_pKiska)
	pButtonOrderFleet.PrependChild(pButtonAttack)
	
	g_pKiska.AddPythonFuncHandlerForInstance(FOLLOW_THROUGH_WARP_FLEET, __name__ + ".FollowThroughWarpFleet")
	pButtonFollow = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Follow"), FOLLOW_THROUGH_WARP_FLEET, 0, g_pKiska)
	pButtonOrderFleet.PrependChild(pButtonFollow)

	g_pKiska.AddPythonFuncHandlerForInstance(ATTACK_MY_TARGET, __name__ + ".AttackMyTarget")
	pButtonFollow = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Attack my Target"), ATTACK_MY_TARGET, 0, g_pKiska)
	pButtonOrderFleet.PrependChild(pButtonFollow)

def Stay(pObject, pEvent):		
	pGame	= App.Game_GetCurrentGame()
	pEpisode	= pGame.GetCurrentEpisode()
	pMission	= pEpisode.GetCurrentMission()
	pFriendlies	= pMission.GetFriendlyGroup()
	pPlayer	= MissionLib.GetPlayer()
	pTarget	= pPlayer.GetTarget()
	pTargetattr	= App.ShipClass_Cast(pTarget)

	if not pTarget:
		print("No Target")
		return
	
	if (pFriendlies.IsNameInGroup(pPlayer.GetTarget().GetName()) != 1):
		print("Target is not friendly - failed.")
		return

	import AI.Player.Stay
	pTargetattr.SetAI(AI.Player.Stay.CreateAI(pTargetattr))

	pSequence = App.TGSequence_Create()
	pSet = App.g_kSetManager.GetSet("bridge")
	if (pSet):
		pHelm = App.CharacterClass_GetObject(pSet, "Helm")
		if (pHelm):
			pSequence.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, "SendingOrders" + str(App.g_kSystemWrapper.GetRandomNumber(2) + 1), "Captain", 1))
	pSequence.Play()
	
	
def FlyForward(pObject, pEvent):		
	pGame	= App.Game_GetCurrentGame()
	pEpisode	= pGame.GetCurrentEpisode()
	pMission	= pEpisode.GetCurrentMission()
	pFriendlies	= pMission.GetFriendlyGroup()
	pPlayer	= MissionLib.GetPlayer()
	pTarget	= pPlayer.GetTarget()
	pTargetattr	= App.ShipClass_Cast(pTarget)

	if not pTarget:
		print("No Target")
		return
	
	if (pFriendlies.IsNameInGroup(pTarget.GetName()) != 1):
		print("Target is not friendly - failed.")
		return

	import AI.Player.FlyForward
	pTargetattr.SetAI(AI.Player.FlyForward.CreateWithAvoid(pTargetattr, 10))

	pSequence = App.TGSequence_Create()
	pSet = App.g_kSetManager.GetSet("bridge")
	if (pSet):
		pHelm = App.CharacterClass_GetObject(pSet, "Helm")
		if (pHelm):
			pSequence.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, "SendingOrders" + str(App.g_kSystemWrapper.GetRandomNumber(2) + 1), "Captain", 1))
	pSequence.Play()


def SelfDestruct(pObject, pEvent):
        import string

	pGame           = App.Game_GetCurrentGame()
	pEpisode	= pGame.GetCurrentEpisode()
	pMission	= pEpisode.GetCurrentMission()
	pFriendlies	= pMission.GetFriendlyGroup()
	pPlayer         = MissionLib.GetPlayer()
	pTarget         = pPlayer.GetTarget()
        pTargetattr	= App.ShipClass_Cast(pTarget)
        ET_ACCEPT       = App.Mission_GetNextEventType()

	if not pTarget:
		print("No Target")
		return
	
        if (pFriendlies.IsNameInGroup(pTarget.GetName()) != 1 and string.find(str(pTarget.GetName()), 'Mine') == "-1"):
                print("Target is not friendly, or a mine - failed.")
                return

	pTargetattr.DestroySystem(pTargetattr.GetHull())
	
	pSequence = App.TGSequence_Create()
	pSet = App.g_kSetManager.GetSet("bridge")
	if (pSet):
		pHelm = App.CharacterClass_GetObject(pSet, "Helm")
		if (pHelm):
			pSequence.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, pHelm.GetCharacterName() + "Yes" + str(App.g_kSystemWrapper.GetRandomNumber(4)+1), "Captain", 1))
	pSequence.Play()


def StayFleet(pObject, pEvent):		
	pGame	= App.Game_GetCurrentGame()
	pEpisode	= pGame.GetCurrentEpisode()
	pMission	= pEpisode.GetCurrentMission()
	pPlayer	= MissionLib.GetPlayer()
	pSet = pPlayer.GetContainingSet()
	pFriendlyGroup = pMission.GetFriendlyGroup()
	pFriendlies	= pMission.GetFriendlyGroup()
	lpFriendlies = pFriendlyGroup.GetActiveObjectTupleInSet(pSet)
	
	import AI.Player.Stay

	for pFriendly in lpFriendlies:
		pTargetattr	= App.ShipClass_Cast(pFriendly)
		if (str(pTargetattr) != str(App.ShipClass_Cast(pPlayer))):
			pTargetattr.SetAI(AI.Player.Stay.CreateAI(pTargetattr))
	
	pSequence = App.TGSequence_Create()
	pSet = App.g_kSetManager.GetSet("bridge")
	if (pSet):
		pHelm = App.CharacterClass_GetObject(pSet, "Helm")
		if (pHelm):
			pSequence.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, "SendingOrders" + str(App.g_kSystemWrapper.GetRandomNumber(2) + 1), "Captain", 1))
	pSequence.Play()
	

def Attack(pObject, pEvent):		
	pGame	= App.Game_GetCurrentGame()
	pEpisode	= pGame.GetCurrentEpisode()
	pMission	= pEpisode.GetCurrentMission()
	pFriendlies	= pMission.GetFriendlyGroup()
	pPlayer	= MissionLib.GetPlayer()
	pTarget	= pPlayer.GetTarget()
	pTargetattr	= App.ShipClass_Cast(pTarget)

	if not pTarget:
		print("No Target")
		return
	
	if (pFriendlies.IsNameInGroup(pPlayer.GetTarget().GetName()) != 1):
		print("Target is not friendly - failed.")
		return
	
	import QuickBattle.QuickBattle
	import Custom.QuickBattleGame.QuickBattle

	# set AI
	# We need to know if we are playing normal QB or QBR:
	# QB
	if QuickBattle.QuickBattle.pFriendlies:
		if (pTargetattr.GetShipProperty().IsStationary() == 1):
			# its a Station
			import QuickBattle.StarbaseFriendlyAI
			pTargetattr.SetAI(QuickBattle.StarbaseFriendlyAI.CreateAI(pTargetattr))
		else:
			import QuickBattle.QuickBattleFriendlyAI
			pTargetattr.SetAI(QuickBattle.QuickBattleFriendlyAI.CreateAI(pTargetattr))
	# QBR
	elif Custom.QuickBattleGame.QuickBattle.pFriendlies:
		if (pTargetattr.GetShipProperty().IsStationary() == 1):
			# its a Station
			import Custom.QuickBattleGame.StarbaseFriendlyAI
			pTargetattr.SetAI(Custom.QuickBattleGame.StarbaseFriendlyAI.CreateAI(pTargetattr, 3, 1, 1))
		else:
			import Custom.QuickBattleGame.QuickBattleFriendlyAI
			pTargetattr.SetAI(Custom.QuickBattleGame.QuickBattleFriendlyAI.CreateAI(pTargetattr, 3, 1, 1))
	
	pSequence = App.TGSequence_Create()
	pSet = App.g_kSetManager.GetSet("bridge")
	if (pSet):
		pHelm = App.CharacterClass_GetObject(pSet, "Helm")
		if (pHelm):
			pSequence.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, "SendingOrders" + str(App.g_kSystemWrapper.GetRandomNumber(2) + 1), "Captain", 1))
	pSequence.Play()
	

def AttackFleet(pObject, pEvent):		
	pGame	= App.Game_GetCurrentGame()
	pEpisode	= pGame.GetCurrentEpisode()
	pMission	= pEpisode.GetCurrentMission()
	pPlayer	= MissionLib.GetPlayer()
	pSet = pPlayer.GetContainingSet()
	pFriendlyGroup = pMission.GetFriendlyGroup()
	pFriendlies	= pMission.GetFriendlyGroup()
	lpFriendlies = pFriendlyGroup.GetActiveObjectTupleInSet(pSet)
	
	import QuickBattle.QuickBattle
	import Custom.QuickBattleGame.QuickBattle
	
	for pFriendly in lpFriendlies:
		pTargetattr	= App.ShipClass_Cast(pFriendly)
		if (str(pTargetattr) != str(App.ShipClass_Cast(pPlayer))):
			# set AI
			# We need to know if we are playing normal QB or QBR:
			# QB
			if QuickBattle.QuickBattle.pFriendlies:
				if (pTargetattr.GetShipProperty().IsStationary() == 1):
					# its a Station
					import QuickBattle.StarbaseFriendlyAI
					pTargetattr.SetAI(QuickBattle.StarbaseFriendlyAI.CreateAI(pTargetattr))
				else:
					import QuickBattle.QuickBattleFriendlyAI
					pTargetattr.SetAI(QuickBattle.QuickBattleFriendlyAI.CreateAI(pTargetattr))
			# QBR
			elif Custom.QuickBattleGame.QuickBattle.pFriendlies:
				if (pTargetattr.GetShipProperty().IsStationary() == 1):
					# its a Station
					import Custom.QuickBattleGame.StarbaseFriendlyAI
					pTargetattr.SetAI(Custom.QuickBattleGame.StarbaseFriendlyAI.CreateAI(pTargetattr, 3, 1, 1))
				else:
					import Custom.QuickBattleGame.QuickBattleFriendlyAI
					pTargetattr.SetAI(Custom.QuickBattleGame.QuickBattleFriendlyAI.CreateAI(pTargetattr, 3, 1, 1))
	
	pSequence = App.TGSequence_Create()
	pSet = App.g_kSetManager.GetSet("bridge")
	if (pSet):
		pHelm = App.CharacterClass_GetObject(pSet, "Helm")
		if (pHelm):
			pSequence.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, "SendingOrders" + str(App.g_kSystemWrapper.GetRandomNumber(2) + 1), "Captain", 1))
	pSequence.Play()
	
	
def FollowThroughWarp(pObject, pEvent):		
	pGame	= App.Game_GetCurrentGame()
	pEpisode	= pGame.GetCurrentEpisode()
	pMission	= pEpisode.GetCurrentMission()
	pFriendlies	= pMission.GetFriendlyGroup()
	pPlayer	= MissionLib.GetPlayer()
	pTarget	= pPlayer.GetTarget()
	pTargetattr	= App.ShipClass_Cast(pTarget)

	if not pTarget:
		print("No Target")
		return
	
	if (pFriendlies.IsNameInGroup(pTarget.GetName()) != 1):
		print("Target is not friendly - failed.")
		return

	if ( pTargetattr.GetShipProperty().IsStationary() == 1 ):
		print("Target is a Station - can't follow.")
		return
		
	pTargetattr.SetAI(CreateAI(pTargetattr))

	pSequence = App.TGSequence_Create()
	pSet = App.g_kSetManager.GetSet("bridge")
	if (pSet):
		pHelm = App.CharacterClass_GetObject(pSet, "Helm")
		if (pHelm):
			pSequence.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, "SendingOrders" + str(App.g_kSystemWrapper.GetRandomNumber(2) + 1), "Captain", 1))
	pSequence.Play()


def FollowThroughWarpFleet(pObject, pEvent):		
	pGame	= App.Game_GetCurrentGame()
	pEpisode	= pGame.GetCurrentEpisode()
	pMission	= pEpisode.GetCurrentMission()
	pPlayer	= MissionLib.GetPlayer()
	pSet = pPlayer.GetContainingSet()
	pFriendlyGroup = pMission.GetFriendlyGroup()
	pFriendlies	= pMission.GetFriendlyGroup()
	lpFriendlies = pFriendlyGroup.GetActiveObjectTupleInSet(pSet)

	for pFriendly in lpFriendlies:
		pTargetattr	= App.ShipClass_Cast(pFriendly)
		if (str(pTargetattr) != str(App.ShipClass_Cast(pPlayer)) and pFriendly.GetShipProperty().IsStationary() == 0 ):
			pTargetattr.SetAI(CreateAI(pTargetattr))

	pSequence = App.TGSequence_Create()
	pSet = App.g_kSetManager.GetSet("bridge")
	if (pSet):
		pHelm = App.CharacterClass_GetObject(pSet, "Helm")
		if (pHelm):
			pSequence.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, "SendingOrders" + str(App.g_kSystemWrapper.GetRandomNumber(2) + 1), "Captain", 1))
	pSequence.Play()


def AttackMyTarget(pObject, pEvent):
        pGame           = App.Game_GetCurrentGame()
	pEpisode	= pGame.GetCurrentEpisode()
	pMission	= pEpisode.GetCurrentMission()
	pPlayer         = MissionLib.GetPlayer()
	pSet            = pPlayer.GetContainingSet()
	pFriendlyGroup  = pMission.GetFriendlyGroup()
	pFriendlies	= pMission.GetFriendlyGroup()
	lpFriendlies    = pFriendlyGroup.GetActiveObjectTupleInSet(pSet)
        pTarget         = pPlayer.GetTarget()
        pEnemies        = pMission.GetEnemyGroup()

	if not pTarget:
		print("No Target")
		return
	
	if (pEnemies.IsNameInGroup(pPlayer.GetTarget().GetName()) != 1):
		print("Target is not enemy - failed.")
		return
        
        import AI.Compound.BasicAttack
        Getg_PlayerTargets(pTarget)
        
	for pFriendly in lpFriendlies:
		pTargetattr	= App.ShipClass_Cast(pFriendly)
		if (str(pTargetattr) != str(App.ShipClass_Cast(pPlayer))):
                        pFriendly.SetAI(AI.Compound.BasicAttack.CreateAI(pFriendly, App.ObjectGroup_FromModule("Custom.QBautostart.FleetUtils", "g_pMyTargetTarget")))

	pSequence = App.TGSequence_Create()
	pSet = App.g_kSetManager.GetSet("bridge")
	if (pSet):
		pHelm = App.CharacterClass_GetObject(pSet, "Helm")
		if (pHelm):
			pSequence.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, "SendingOrders" + str(App.g_kSystemWrapper.GetRandomNumber(2) + 1), "Captain", 1))
	pSequence.Play()


def Getg_PlayerTargets(pTarget):
	global g_pMyTargetTarget
	
	g_pMyTargetTarget = None
	g_pMyTargetTarget = App.ObjectGroup()
	g_pMyTargetTarget.AddName(pTarget.GetName())


# From Maelstrom.Episode4.E4M4.FollowPlayerAI, only changed the string "Player" to pPlayer.GetName()
def CreateAI(pShip):
	pPlayer = MissionLib.GetPlayer()

        Random = lambda fMin, fMax : App.g_kSystemWrapper.GetRandomNumber((fMax - fMin) * 1000.0) / 1000.0 - fMin
        # Range values used in the AI.
        fInRange = 150.0 + Random(-25, 20)

	#########################################
	# Creating PlainAI Intercept at (279, 253)
	pIntercept = App.PlainAI_Create(pShip, "Intercept")
	pIntercept.SetScriptModule("Intercept")
	pIntercept.SetInterruptable(1)
	pScript = pIntercept.GetScriptInstance()
	pScript.SetTargetObjectName(pPlayer.GetName())
	# Done creating PlainAI Intercept
	#########################################
	#########################################
	# Creating ConditionalAI ConditionIntercept at (148, 273)
	## Conditions:
	#### Condition HaveToIntercept
	pHaveToIntercept = App.ConditionScript_Create("Conditions.ConditionInRange", "ConditionInRange", fInRange, pPlayer.GetName(), pShip.GetName())
	## Evaluation function:
	def EvalFunc(bHaveToIntercept):
		ACTIVE = App.ArtificialIntelligence.US_ACTIVE
		DORMANT = App.ArtificialIntelligence.US_DORMANT
		DONE = App.ArtificialIntelligence.US_DONE
		if not bHaveToIntercept:
			return ACTIVE
		return DORMANT
	## The ConditionalAI:
	pConditionIntercept = App.ConditionalAI_Create(pShip, "ConditionIntercept")
	pConditionIntercept.SetInterruptable(1)
	pConditionIntercept.SetContainedAI(pIntercept)
	pConditionIntercept.AddCondition(pHaveToIntercept)
	pConditionIntercept.SetEvaluationFunction(EvalFunc)
	# Done creating ConditionalAI ConditionIntercept
	#########################################
	#########################################
	# Creating PlainAI Follow at (280, 181)
	pFollow = App.PlainAI_Create(pShip, "Follow")
	pFollow.SetScriptModule("FollowObject")
	pFollow.SetInterruptable(1)
	pScript = pFollow.GetScriptInstance()
	pScript.SetFollowObjectName(pPlayer.GetName())
	pScript.SetRoughDistances(10,20,30)
	# Done creating PlainAI Follow
	#########################################
	#########################################
	# Creating ConditionalAI PlayerInSameSet at (164, 201)
	## Conditions:
	#### Condition InSet
	pInSet = App.ConditionScript_Create("Conditions.ConditionAllInSameSet", "ConditionAllInSameSet", pShip.GetName(), pPlayer.GetName())
	## Evaluation function:
	def EvalFunc(bInSet):
		ACTIVE = App.ArtificialIntelligence.US_ACTIVE
		DORMANT = App.ArtificialIntelligence.US_DORMANT
		DONE = App.ArtificialIntelligence.US_DONE
		if bInSet:
			# Player is in the same set as we are.
			return ACTIVE
		return DORMANT
	## The ConditionalAI:
	pPlayerInSameSet = App.ConditionalAI_Create(pShip, "PlayerInSameSet")
	pPlayerInSameSet.SetInterruptable(1)
	pPlayerInSameSet.SetContainedAI(pFollow)
	pPlayerInSameSet.AddCondition(pInSet)
	pPlayerInSameSet.SetEvaluationFunction(EvalFunc)
	# Done creating ConditionalAI PlayerInSameSet
	#########################################
	#########################################
	# Creating CompoundAI FollowWarp at (281, 125)
	import AI.Compound.FollowThroughWarp
	pFollowWarp = AI.Compound.FollowThroughWarp.CreateAI(pShip, pPlayer.GetName())
	# Done creating CompoundAI FollowWarp
	#########################################
	#########################################
	# Creating PriorityListAI PriorityList at (47, 125)
	pPriorityList = App.PriorityListAI_Create(pShip, "PriorityList")
	pPriorityList.SetInterruptable(1)
	# SeqBlock is at (139, 132)
	pPriorityList.AddAI(pConditionIntercept, 1)
	pPriorityList.AddAI(pPlayerInSameSet, 2)
	pPriorityList.AddAI(pFollowWarp, 3)
	# Done creating PriorityListAI PriorityList
	#########################################
	#########################################
	# Creating PreprocessingAI AvoidObstacles at (6, 188)
	## Setup:
	import AI.Preprocessors
	pScript = AI.Preprocessors.AvoidObstacles()
	## The PreprocessingAI:
	pAvoidObstacles = App.PreprocessingAI_Create(pShip, "AvoidObstacles")
	pAvoidObstacles.SetInterruptable(1)
	pAvoidObstacles.SetPreprocessingMethod(pScript, "Update")
	pAvoidObstacles.SetContainedAI(pPriorityList)
	# Done creating PreprocessingAI AvoidObstacles
	#########################################
	return pAvoidObstacles
